package com.bpcl.lpg.core.dao.impl;

import de.hybris.platform.servicelayer.search.SearchResult;
import java.util.Collections;
import java.util.Objects;
import java.util.Map;
import de.hybris.platform.servicelayer.search.FlexibleSearchQuery;
import java.util.HashMap;
import java.util.List;
import com.bpcl.lpg.core.enums.GenericStatusEnum;
import java.util.Date;
import com.bpcl.lpg.core.dao.DbcRequestDao;
import com.bpcl.lpg.core.model.LpgDBCRequestModel;
import de.hybris.platform.servicelayer.internal.dao.DefaultGenericDao;

public class DbcRequestDaoImpl extends DefaultGenericDao<LpgDBCRequestModel> implements DbcRequestDao
{
    public DbcRequestDaoImpl(final String typecode) {
        super(typecode);
    }
    
    public List<LpgDBCRequestModel> getDbcRequestsByStatus(final Date startDate, final Date endDate, final GenericStatusEnum status) {
        final StringBuilder query = new StringBuilder("SELECT {dbc.pk} from {").append("LpgDBCRequest").append(" as dbc ").append("JOIN ").append("GenericStatusEnum").append(" as gse on {dbc.").append("status").append("}={gse.pk}} ").append("WHERE {gse.code}=?").append("status").append(" AND {dbc.").append("creationtime").append("}>= ?").append("startTime").append(" AND {dbc.").append("creationtime").append("}<= ?").append("endTime");
        final Map<String, Object> param = new HashMap<String, Object>();
        param.put("status", status.getCode());
        param.put("startTime", startDate);
        param.put("endTime", endDate);
        final FlexibleSearchQuery flexibleSearchQuery = new FlexibleSearchQuery(query);
        flexibleSearchQuery.addQueryParameters((Map)param);
        final SearchResult<LpgDBCRequestModel> search = (SearchResult<LpgDBCRequestModel>)this.getFlexibleSearchService().search(flexibleSearchQuery);
        return Objects.isNull(search) ? Collections.emptyList() : search.getResult();
    }
}
